searchData={"content_type":"text/markdown","items":[{"doc":"The order that the attributes appear in the columns of the CSV","ref":"dsl-ashcsv-datalayer.html#csv-columns","title":"AshCsv.DataLayer.csv.columns","type":"DSL"},{"doc":"The separator to use, defaults to a comma. Pass in a character (not a string).","ref":"dsl-ashcsv-datalayer.html#csv-separator","title":"AshCsv.DataLayer.csv.separator","type":"DSL"},{"doc":"If the csv file has a header that should be skipped","ref":"dsl-ashcsv-datalayer.html#csv-header?","title":"AshCsv.DataLayer.csv.header?","type":"DSL"},{"doc":"Whether or not the file should be created if it does not exist (this will only happen on writes)","ref":"dsl-ashcsv-datalayer.html#csv-create?","title":"AshCsv.DataLayer.csv.create?","type":"DSL"},{"doc":"The file to read the data from","ref":"dsl-ashcsv-datalayer.html#csv-file","title":"AshCsv.DataLayer.csv.file","type":"DSL"},{"doc":"","ref":"dsl-ashcsv-datalayer.html#csv","title":"AshCsv.DataLayer.csv","type":"DSL"},{"doc":"A CSV datalayer for the Ash framework\n\nFor DSL documentation, see `AshCsv.DataLayer`","ref":"AshCsv.html","title":"AshCsv","type":"module"},{"doc":"The data layer implementation for AshCsv","ref":"AshCsv.DataLayer.html","title":"AshCsv.DataLayer","type":"module"},{"doc":"","ref":"AshCsv.DataLayer.html#columns/1","title":"AshCsv.DataLayer.columns/1","type":"function"},{"doc":"","ref":"AshCsv.DataLayer.html#create?/1","title":"AshCsv.DataLayer.create?/1","type":"function"},{"doc":"","ref":"AshCsv.DataLayer.html#file/1","title":"AshCsv.DataLayer.file/1","type":"function"},{"doc":"","ref":"AshCsv.DataLayer.html#filter_matches/3","title":"AshCsv.DataLayer.filter_matches/3","type":"function"},{"doc":"","ref":"AshCsv.DataLayer.html#header?/1","title":"AshCsv.DataLayer.header?/1","type":"function"},{"doc":"","ref":"AshCsv.DataLayer.html#separator/1","title":"AshCsv.DataLayer.separator/1","type":"function"},{"doc":"Introspection helpers for AshCsv.DataLayer","ref":"AshCsv.DataLayer.Info.html","title":"AshCsv.DataLayer.Info","type":"module"},{"doc":"","ref":"AshCsv.DataLayer.Info.html#columns/1","title":"AshCsv.DataLayer.Info.columns/1","type":"function"},{"doc":"","ref":"AshCsv.DataLayer.Info.html#create?/1","title":"AshCsv.DataLayer.Info.create?/1","type":"function"},{"doc":"","ref":"AshCsv.DataLayer.Info.html#file/1","title":"AshCsv.DataLayer.Info.file/1","type":"function"},{"doc":"","ref":"AshCsv.DataLayer.Info.html#header?/1","title":"AshCsv.DataLayer.Info.header?/1","type":"function"},{"doc":"","ref":"AshCsv.DataLayer.Info.html#separator/1","title":"AshCsv.DataLayer.Info.separator/1","type":"function"},{"doc":"![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-black-text.png?raw=true#gh-light-mode-only)\n![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-white-text.png?raw=true#gh-dark-mode-only)\n\n![Elixir CI](https://github.com/ash-project/ash_csv/workflows/CI/badge.svg)\n[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)\n[![Hex version badge](https://img.shields.io/hexpm/v/ash_csv.svg)](https://hex.pm/packages/ash_csv)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/ash_csv)\n\n# AshCsv\n\nWelcome! This is the CSV Data Layer for [Ash Framework](https://hexdocs.pm/ash).","ref":"readme.html","title":"Home","type":"extras"},{"doc":"- [Getting Started with AshCsv](documentation/tutorials/getting-started-with-ash-csv.md)","ref":"readme.html#tutorials","title":"Tutorials - Home","type":"extras"},{"doc":"- [AshCsv.DataLayer DSL](documentation/dsls/DSL:-AshCsv.DataLayer.md)","ref":"readme.html#reference","title":"Reference - Home","type":"extras"},{"doc":"# Getting Started with CSV\n\nAshCsv offers basic support for storing and reading resources from csv files.","ref":"getting-started-with-ash-csv.html","title":"Getting Started with CSV","type":"extras"},{"doc":"Add `ash_csv` to your list of dependencies in `mix.exs`:\n\n```elixir\n{:ash_csv, \"~> 0.9.7-rc.0\"}\n```\n\nFor information on how to configure it, see the [DSL documentation.](/documentation/dsls/DSL:-AshCsv.DataLayer.md)","ref":"getting-started-with-ash-csv.html#installation","title":"Installation - Getting Started with CSV","type":"extras"},{"doc":"<!--\nThis file was generated by Spark. Do not edit it by hand.\n-->\n# DSL: AshCsv.DataLayer\n\nThe data layer implementation for AshCsv","ref":"dsl-ashcsv-datalayer.html","title":"DSL: AshCsv.DataLayer","type":"extras"},{"doc":"","ref":"dsl-ashcsv-datalayer.html#csv","title":"csv - DSL: AshCsv.DataLayer","type":"extras"},{"doc":"```\ncsv do\n  file \"priv/data/tags.csv\"\n  create? true\n  header? true\n  separator '-'\n  columns [:id, :name]\nend\n\n```","ref":"dsl-ashcsv-datalayer.html#examples","title":"Examples - DSL: AshCsv.DataLayer","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n|------|------|---------|------|\n| [`file`](#csv-file){: #csv-file .spark-required} | `String.t` |  | The file to read the data from |\n| [`create?`](#csv-create?){: #csv-create? } | `boolean` | `false` | Whether or not the file should be created if it does not exist (this will only happen on writes) |\n| [`header?`](#csv-header?){: #csv-header? } | `boolean` | `false` | If the csv file has a header that should be skipped |\n| [`separator`](#csv-separator){: #csv-separator } | `any` | `44` | The separator to use, defaults to a comma. Pass in a character (not a string). |\n| [`columns`](#csv-columns){: #csv-columns } | `any` |  | The order that the attributes appear in the columns of the CSV |\n\n\n\n\n\n\n\n .spark-required::after { content: \"*\"; color: red !important; }","ref":"dsl-ashcsv-datalayer.html#options","title":"Options - DSL: AshCsv.DataLayer","type":"extras"},{"doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v0.9.7](https://github.com/ash-project/ash_csv/compare/v0.9.7...v0.9.7) (2024-05-11)","ref":"changelog.html","title":"Change Log","type":"extras"},{"doc":"* performance gains via compile time building of parser/dumper\n\n* performance improvements\n\n## [v0.9.7](https://github.com/ash-project/ash_csv/compare/v0.9.7-rc.0...v0.9.7) (2024-05-11)","ref":"changelog.html#improvements","title":"Improvements: - Change Log","type":"extras"},{"doc":"* performance gains via compile time building of parser/dumper\n\n* performance improvements\n\n## [v0.9.7-rc.0](https://github.com/ash-project/ash_csv/compare/v0.9.6...v0.9.7-rc.0) (2024-03-30)","ref":"changelog.html#improvements","title":"Improvements: - Change Log","type":"extras"},{"doc":"* support Ash 3.0\n\n## [v0.9.6](https://github.com/ash-project/ash_csv/compare/v0.9.5...v0.9.6) (2023-10-08)","ref":"changelog.html#improvements","title":"Improvements: - Change Log","type":"extras"},{"doc":"* `ash_csv` doesn't support don't do expression calculations\n\n## [v0.9.5](https://github.com/ash-project/ash_csv/compare/v0.9.4...v0.9.5) (2023-10-05)","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"},{"doc":"* handle expression calcs & expression calc sorting\n\n## [v0.9.4](https://github.com/ash-project/ash_csv/compare/v0.9.3...v0.9.4) (2023-08-03)","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"},{"doc":"* support latest `ash`\n\n## [v0.9.3](https://github.com/ash-project/ash_csv/compare/v0.9.2...v0.9.3) (2023-08-02)","ref":"changelog.html#improvements","title":"Improvements: - Change Log","type":"extras"},{"doc":"* fix upsert behavior\n\n* support latest ash\n\n## [v0.9.2](https://github.com/ash-project/ash_csv/compare/v0.9.1...v0.9.2) (2023-01-18)","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"},{"doc":"* properly set header when creating file","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"},{"doc":"* update ash and new docs patterns\n\n* support latest ash\n\n* update ash and update behavior function\n\n* use new docs\n\n* better behavior around creating missing files\n\n## [v0.9.1](https://github.com/ash-project/ash_csv/compare/v0.9.0-rc.0...v0.9.1) (2022-10-24)","ref":"changelog.html#improvements","title":"Improvements: - Change Log","type":"extras"},{"doc":"* `:global.trans` doesn't support timeouts, we were passing in the timeout","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"},{"doc":"* update ash version\n\n## [v0.8.3](https://github.com/ash-project/ash_csv/compare/v0.8.2...v0.8.3) (2021-03-29)","ref":"changelog.html#improvements","title":"Improvements: - Change Log","type":"extras"},{"doc":"* don't use dump_to_native on updates either\n\n## [v0.8.2](https://github.com/ash-project/ash_csv/compare/v0.8.1...v0.8.2) (2021-03-29)","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"},{"doc":"* don't use `dump_to_native`, as CSV is really just string representations","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"},{"doc":"* update CSV\n\n## [v0.8.1](https://github.com/ash-project/ash_csv/compare/v0.8.0...v0.8.1) (2021-02-23)","ref":"changelog.html#improvements","title":"Improvements: - Change Log","type":"extras"},{"doc":"* support latest ash\n\n## [v0.8.0](https://github.com/ash-project/ash_csv/compare/v0.7.0-rc0...v0.8.0) (2021-01-22)","ref":"changelog.html#improvements","title":"Improvements: - Change Log","type":"extras"},{"doc":"* support latest ash version\n\n## [v0.7.0-rc0](https://github.com/ash-project/ash_csv/compare/v0.6.2...v0.7.0-rc0) (2021-01-22)","ref":"changelog.html#improvements","title":"Improvements: - Change Log","type":"extras"},{"doc":"* update to latest ash\n\n## [v0.6.2](https://github.com/ash-project/ash_csv/compare/v0.6.1...v0.6.2) (2020-12-27)","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* update to latest ash\n\n## [v0.6.1](https://github.com/ash-project/ash_csv/compare/v0.6.0...v0.6.1) (2020-10-27)","ref":"changelog.html#improvements","title":"Improvements: - Change Log","type":"extras"},{"doc":"* add separator_opt validator\n\n## [v0.6.0](https://github.com/ash-project/ash_csv/compare/v0.5.0...v0.6.0) (2020-10-10)","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"},{"doc":"* update to latest ash\n\n## [v0.5.0](https://github.com/ash-project/ash_csv/compare/v0.4.0...v0.5.0) (2020-10-06)","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* tests + fixes","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* update ash matrix\n\n## [v0.4.0](https://github.com/ash-project/ash_csv/compare/v0.3.0...v0.4.0) (2020-10-06)","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"},{"doc":"* tests + fixes\n\n## [v0.3.0](https://github.com/ash-project/ash_csv/compare/v0.2.0...v0.3.0) (2020-08-26)","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* update to ash 1.11\n\n## [v0.2.0](https://github.com/ash-project/ash_csv/compare/v0.1.1...v0.2.0) (2020-08-26)","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* update to ash 1.11\n\n## [v0.1.1](https://github.com/ash-project/ash_csv/compare/v0.1.0...v0.1.1) (2020-08-20)\n\n\n\n\n## [v0.1.0](https://github.com/ash-project/ash_csv/compare/v0.1.0...v0.1.0) (2020-08-20)","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* initial feature release","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* fixes/dialyzer/credo","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}